Core - Task # 53687

Epic # 55070 (Accepted): Workpackages

Epic # 54260 (Accepted): WP: FAL Missing Issues / Features / API
Story # 54263 (Resolved): As an Integrator | want to have my metadata present at places when using files
Task # 52778 (Resolved): No metadata shown for Folder and Category bases collections

Status: Resolved Priority: Must have

Author: Steffen Ritter Category: File Abstraction Layer (FAL)
Created: 2013-11-16 Assigned To: Steffen Ritter

Updated: 2014-02-17 Due date: 2013-12-31

TYPO3 Version: 6.2

PHP Version:

Complexity: medium

Sprint Focus:

Subject: FileRepository:getFileIndexRecordsForFolder only works for hierarchical path

Description

Sorry for german, but | did not want to translate it all... Just for documentation purposes so its not lost

Die Art und weise wie die Query aufgebaut ist, funktioniert nur wenn das Dateisystem seine Identifier hierarchisch mit slashes trennt.

- Im FilelndexRepository soll eine ahnliche Methode geschaffen werden, die die Daten aber Uber den neuen ,Folder-Hash* in der
Datei-Tabelle sucht. Das ist a, wesentlich Performanter und b, funktioniert mit jedem Treiber, Parameter ist Sinnvollerweise der
Folder-Hash direkt

- Um die spatere Verwendung effizienter zu gestalten sollter der Identifier im Key des arrays stehen (letzter Parameter
exec_SELECTgetRows)

- Eventuell muss hier ein Index auf diese Spalte hinzugefuigt werden.

- Die Methode in im FileRepository soll deprecated werden, un deren Inhalt ersetzt mit einem Aufruf auf das FilelndexRepository.

- Die Verwendung der deprecated Method soll durch die neue ersetzt werden.

Related issues:
precedes Core - Task # 53688: ResourceFactory::createFileObject is called fro... Resolved 2014-01-01 2014-02-15

Associated revisions

Revision b100e06f - 2013-12-21 11:02 - Steffen Ritter

[BUGFIX] getFileIndexRecordsForFolder only works for hierarchical path

The method FileRepository::getFilelndexRecordsForFolder
retrieves the Index Records for files in a given folder using a
LIKE-query. This basically checks if the identifier of the a
folder is part of the identifier of the file.

This concept has several drawbacks. First not all storages are
hierarchical, second this will fail if there is a different

directory seperator than / and finally this fetches records

for the folder recursively which may result in a huge amount of
data if for example the root folder of an storage is queried.

In addition the method resides in the FileRepository while it
retrieves IndexRecords - which is a different concern.
This change introduces the function within the
FilelIndexRepository and uses the folder_hash (introduced in
https://review.typo3.0rg/23398) to query for the files.

The old method is deprecated now, calls the new method and
all core-usages of the old function have been rewritten to
use the new functionality.

Releases: 6.2

Resolves: #53687

Change-Id: Icabf2350192c93951f2277f3aa7468fe958bfabf
Reviewed-on: https://review.typo3.org/26357

Reviewed-by: Frans Saris
Tested-by: Frans Saris
Reviewed-by: Steffen Ritter
Tested-by: Steffen Ritter

History

#1 - 2013-11-30 16:15 - Steffen Ritter
- Assigned To set to Steffen Ritter

#2 - 2013-11-30 21:27 - Steffen Ritter

- Complexity set to medium

#3 - 2013-12-06 11:55 - Steffen Ritter
- Due date set to 2013-12-31
- Estimated time set to 4.00

#4 - 2013-12-12 16:51 - Steffen Ritter
- % Done changed from 0 to 10

#5 - 2013-12-12 17:23 - Gerrit Code Review

- Status changed from Accepted to Under Review

Patch set 1 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.

It is available at https://review.typo3.0rg/26357

#6 - 2013-12-12 17:24 - Steffen Ritter
- % Done changed from 10 to 70

#7 - 2013-12-12 20:07 - Gerrit Code Review

Patch set 2 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.

It is available at https://review.typo3.0rg/26357

#8 - 2013-12-21 11:12 - Steffen Ritter
- % Done changed from 70 to 90

#9 - 2013-12-21 11:30 - Steffen Ritter
https://review.typo3.org/23398
https://review.typo3.org/26357
https://review.typo3.org/26357
https://review.typo3.org/26357

- Status changed from Under Review to Resolved

- % Done changed from 90 to 100

Applied in changeset commit:b100e06f68406729a9f884ba5ab0aab37867a58b.

#10 - 2013-12-21 11:59 - Steffen Ritter
- % Done changed from 100 to 90

#11 - 2014-02-17 08:56 - Steffen Ritter
- % Done changed from 90 to 100
